/******************************************************************************
*
* These TV POWER codes were compiled by Mitch Altman/Cornfield Electronics 
* for use with his TV-B-Gone product (http://www.tvbgone.com). In 2007, Mitch 
* joined forces with Limor Fried to release a kit version along with source 
* (http://www.ladyada.net/make/tvbgone/index.html). The portions used in this
* DC16 badge are distributed under Creative Commons 2.5 -- Attib & Share Alike
*
* Says Mitch from the TV-B-Gone kit main.c:
* "The tricky part of TV-B-Gone was collecting all of the POWER codes, and 
* getting rid of the duplicates and near-duplicates (because if there is a 
* duplicate, then one POWER code will turn a TV off, and the duplicate will 
* turn it on again (which we certainly do not want)."
*
* Thanks to Albert Yarusso (http://www.atariage.com) for helping with porting
* and debugging.
*
*******************************************************************************/
#include "FslTypes.h"
#include "DC16.h"

  

// Code 005 -- Philips, Grundig, Pye
static const powercode philipsCode  = {
  freq_to_timerval( 34800), // 34.8 KHz
  {  {  92,    92 },
     { 184,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,   184 },
     {  92,    92 },
     { 184,    92 },
     {  92,  9216 },
     {  92,    92 },
     { 184,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,   184 },
     {  92,    92 },
     { 184,    92 },
     {  92,     0 },
  }
};

// code 0 ('11000000000000')
static const powercode MMphilips0 = {
  freq_to_timerval( 34800), // 34.8 KHz
  {  {  92,    92 },
     { 184,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 }, 
     {  92,     0 }
      
  }
}; 

// code up ('11000000010000')
static const powercode MMphilipsUp = {
  freq_to_timerval( 34800), // 34.8 KHz
  {  {  92,    92 },
     { 184,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,   184 },
     { 184,    92 },
     {  92,    92 },
     {  92,    92 }, 
     {  92,     0 }
      
  }
};

// code prog+ ('11000000100000')
static const powercode MMphilipsProgPlus = {
  freq_to_timerval( 34800), // 34.8 KHz
  {  {  92,    92 },
     { 184,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,    92 },
     {  92,   184 },
     { 184,    92 },
     {  92,    92 }, 
     {  92,    92 }, 
     {  92,    92 }, 
     {  92,     0 }
      
  }
};


// tvsetup2 ('11000111101110')
static const powercode MMphilipsTVBP0wn = {
  freq_to_timerval( 34800), 
  {  {  92,    92 },
     { 184,    92 },
     {  92,    92 },
     {  92,   184 },
     {  92,    92 },
     {  92,    92 },
     {  92,   184 }, 
     {  92,   184 }, 
     {  92,    92 }, 
     {  92,   184 }, 
     {  92,     0 }
  }
};
    
        

//const powercode *powerCodes[]  = {
//  &sonyCode, &rcaCode, &panasonicCode, &sharpCode, &toshibaCode,
//  &philipsCode, &samsungCode,&zenithCode, &pioneerCode, &sylvaniaCode,
//  &jvcCode, &hitachiCode, &sampoCode, &hisenseCode, &viewsonicCode,
//  &bushCode, &aocCode, &bellCode, &pioneer2Code, &fujitsuCode,
//  &goldstarCode, &daewooCode, &NECCode, &admiralCode, &sony2Code,
//  &viewsonic2Code, &zenith2Code, &thompsonCode, &brillianCode, &magnavoxCode,
//  &viewsonic3Code, &crownCode, &hitachi2Code, &fujitsu2Code, &hitachi3Code,
//  &NEC2Code, &hitachi4Code, &anamCode, &aoc2Code, &candleCode,
//  &contecCode, &contec2Code, &sony3Code, &alleronCode, &contec3Code,
//  &curtisCode, &aikoCode, &daewoo2Code, &electrohomeCode, &emersonCode,
//  &fisherCode, &amplivisionCode, &geCode, &jvc2Code, &jvc3Code, &klossCode
//};

const powercode *powerCodes[] = {
//  &MMphilips0
//  &philipsCode
//  &MMphilipsTVBP0wn
//  &MMphilipsUp
  &MMphilipsProgPlus
};


unsigned char num_codes = (sizeof(powerCodes)/sizeof(*powerCodes));
